<?php

namespace Lc\SovBundle\Repository;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Lc\SovBundle\Doctrine\EntityInterface;

interface RepositoryQueryInterface
{
    public function create();

    public function call(callable $fn): \Lc\SovBundle\Repository\AbstractRepositoryQuery;

    public function count(): string;

    public function findOne(): ?EntityInterface;

    public function find(): array;

    public function limit(int $maxResults);

    public function paginate(int $page = 1, int $limit = 20);

    public function getRepository(): ServiceEntityRepository;

    public function groupBy(string $field): \Lc\SovBundle\Repository\AbstractRepositoryQuery;

    public function orderBy(string $field, string $sort = 'ASC'): \Lc\SovBundle\Repository\AbstractRepositoryQuery;

    public function filterById(int $id);

    public function filterByDevAlias(string $devAlias): \Lc\SovBundle\Repository\AbstractRepositoryQuery;

    public function filterBySlug(string $slug);

    public function filterIsParent();

    public function filterIsChildren();

    public function filterByParent(EntityInterface $parent);

    public function filterByStatus($status): \Lc\SovBundle\Repository\AbstractRepositoryQuery;

    public function filterIsOffline(): \Lc\SovBundle\Repository\AbstractRepositoryQuery;

    public function filterIsOnline(): \Lc\SovBundle\Repository\AbstractRepositoryQuery;

    public function filterIsDeleted(): \Lc\SovBundle\Repository\AbstractRepositoryQuery;

    public function filterIsOnlineAndOffline(): \Lc\SovBundle\Repository\AbstractRepositoryQuery;
}